/*
 * Pmod8LD.h
 *
 *  Created on: Oct 29, 2017
 *      Author: Krzysztof Chojnowski
 */

#ifndef PMOD8LD_H_
#define PMOD8LD_H_

typedef enum {
	Pmod8LD_Led0,
	Pmod8LD_Led1,
	Pmod8LD_Led2,
	Pmod8LD_Led3,
	Pmod8LD_Led4,
	Pmod8LD_Led5,
	Pmod8LD_Led6,
	Pmod8LD_Led7,
} Pmod8LD_Led;

/**
 * @brief Configure ARDUINO CONNECTOR pins as GPIO outputs.
 *        PD10 -> LED0
 *        PB11 -> LED1
 *        PD11 -> LED2
 *        PB13 -> LED3
 *        PB12 -> LED4
 *        PB15 -> LED5
 *        PB14 -> LED6
 *        PB10 -> LED7
 */
void Pmod8LD_Config(void);

/**
 * @brief Turn on given led.
 */
void Pmod8LD_SetLed(Pmod8LD_Led led);

/**
 * @brief Turn off given led.
 */
void Pmod8LD_ResetLed(Pmod8LD_Led led);

#endif /* PMOD8LD_H_ */
